# What's New in Windows Admin Center SDK 
Here is a list of features added to the SDK in the most recent release.

## SDK 1803:

### More UI control samples and UI style documentation
Hello Extension has expanded to include more examples than ever!  Hello Extension is now called Developer Tools, and has grown into a solution extension containing two tools: first, the original set of API Examples; and second, a brand-new tool named Development Guide. This new tool contains an expansive library of controls that are used in Windows Admin Center, and a comprehensive UI style guide covering Colors, Form Elements, Icons, Themes, and more!  Use Development Guide to browse through examples of our controls in runtime, and then go to the SDK to see how to implement them in code.

## SDK 1802:

### Solution Extension Example
The SDK now includes a pre-built solution extension that you can use as a reference to build your own solutions.

### IFrame Extension Example
The SDK now includes an example of hosting an IFrame inside an extension to load external content.

### Dynamic Tools Menu
Instructions are now available for how to conditionally hide or show tools inside the tools menu.

### Angular 5 Upgrade
Windows Admin Center and all included extensions have been upgraded to use Angular 5.  Included are details on how to upgrade your environment.  Tools built on previous versions of Angular are still supported, but upgrading to Angular 5 is suggested.

### Windows Admin Center custom data and tree grids
We have removed dependencies on the Prime data grid, and are now including the Windows Admin Center data and tree grids.  These grids are accessibility enabled, covering all requirements for keyboard navigation and Narrator support.  Documentation for usage has been updated as well.


### Environment Upgrade details
We have included steps to upgrade your local development environment to the appropriate versions of Angular and Node.  These instructions can be found in the Getting Started document [here](getting-started.md).

## SDK 1711:

### Publish your extension
Instructions are now available for overriding your nuget feed to publish extensions internally.  For more information about publishing, click [here](publish-your-extension.md).

### Create a Solution Extension
The SDK now includes instructions and sample code showing how to publish a basic solution extension (one without a tools menu).  Additional solution extension functionality will be available in an upcoming release.  For information about creating a solution extension, click [here](solution-extension.md).

### Create a Gateway API Extension
The SDK now includes instructions and sample code showing how to create and install a gateway API extension, as well as calling that gateway extension from a tool.  For more information about gateway extensions, click [here](gateway-extensions.md).

###  Empty Extension
Sample code is now available for an empty extension, that can be used as a starting point for your extensibility project.
